dir(0,1). dir(0,-1). dir(1,0). dir(-1,0).

in(A) :- area(X,Y,A).

filled(X,Y) :- area(X,Y,A).
numbered(X,Y) :- number(X,Y,N).

pass(X,Y) :- cell(X,Y), not numbered(X,Y).
next(X1,Y1,X2,Y2,DX,DY) :- cell(X1,Y1), dir(DX,DY), X2 = X1+DX, Y2 = Y1+DY, pass(X2,Y2).

go(X,Y,X1,Y1,DX,DY) :- numbered(X,Y), next(X,Y,X1,Y1,DX,DY).
go(X,Y,X2,Y2,DX,DY) :- go(X,Y,X1,Y1,DX,DY), next(X1,Y1,X2,Y2,DX,DY).

nogoal(X,Y,X1,Y1) :- go(X,Y,X1,Y1,DX,DY), not filled(X1,Y1).
nogoal(X,Y,X1,Y1) :- go(X,Y,X1,Y1,DX,DY), number(X,Y,N), area(X1,Y1,A), goal(A,G), G < N.
% nogoal(X,Y,X2,Y2) :- go(X,Y,X1,Y1,DX,DY), go(X,Y,X2,Y2,DX,DY), area(X1,Y1,A), area(X2,Y2,A),
%                      DX*(X1+DX) <= DX*X2, DY*(Y1+DY) <= DY*Y2.

poss(X,Y,X1,Y1,DX,DY) :- go(X,Y,X1,Y1,DX,DY), not nogoal(X,Y,X1,Y1).

{ move(X,Y,X1,Y1) } :- poss(X,Y,X1,Y1,DX,DY).
move(X,Y,X1,Y1) :- go(X,Y,X1,Y1,DX,DY), next(X1,Y1,X2,Y2,DX,DY), move(X,Y,X2,Y2).
:- pass(X1,Y1), #count{X,Y : move(X,Y,X1,Y1)} > 1.
:- numbered(X,Y), #count{X1,Y1 : move(X,Y,X1,Y1), next(X,Y,X1,Y1,DX,DY)} != 1.

target(X,Y,X1,Y1) :- move(X,Y,X1,Y1), poss(X,Y,X1,Y1,DX,DY), not move(X,Y,X1+DX,Y1+DY).
:- in(A), #count{X,Y : target(X,Y,X1,Y1), area(X1,Y1,A)} < 1.
:- goal(A,G), #sum{N,X,Y : target(X,Y,X1,Y1), area(X1,Y1,A), number(X,Y,N)} != G.

#show target/4.
