dir(bishop,1,1). dir(bishop,1,-1). dir(bishop,-1,1). dir(bishop,-1,-1).
dir(rook,0,1).   dir(rook,0,-1).   dir(rook,1,0).    dir(rook,-1,0).

other(bishop,DX,DY) :- dir(rook,DX,DY).
other(rook,DX,DY) :- dir(bishop,DX,DY).

next(X1,Y1,X2,Y2,DX,DY) :- cell(X1,Y1), cell(X2,Y2), dir(P,DX,DY), X2 = X1+DX, Y2 = Y1+DY.

{ place(bishop,X,Y); place(rook,X,Y) } < 2 :- cell(X,Y).
:- place(P,X1,Y1), place(P,X2,Y2), next(X1,Y1,X2,Y2,DX,DY), other(P,DX,DY), 0 < 2*DX+DY.

attack(X2,Y2,DX,DY) :- next(X1,Y1,X2,Y2,DX,DY), dir(P,DX,DY), place(P,X1,Y1).
attack(X2,Y2,DX,DY) :- next(X1,Y1,X2,Y2,DX,DY), other(P,DX,DY), attack(X1,Y1,DX,DY), not place(P,X1,Y1).
:- place(P,X,Y), attack(X,Y,DX,DY), dir(P,DX,DY).

attacked(P,X,Y) :- attack(X,Y,DX,DY), other(P,DX,DY).
:- place(P,X,Y), not attacked(P,X,Y).
:- cell(X,Y), not attacked(bishop,X,Y), not attacked(rook,X,Y).

:~ place(P,X,Y). [2,X,Y]
:~ place(rook,X,Y). [1,X,Y]

#show place/3.
